#include <Joystick.h>

Joystick_ Joystick(JOYSTICK_DEFAULT_REPORT_ID, JOYSTICK_TYPE_JOYSTICK,
  10, 1,                  // Button Count, Hat Switch Count
  false, false, false,     // X and Y, but no Z Axis
  false, false, false,   // No Rx, Ry, or Rz
  false, false,          // No rudder or throttle
  false, false, false);  // No accelerator, brake, or steering

#define joyButton1 0
#define joyButton2 1
#define joyButton3 2
#define joyButton4 3
#define joyButton5 8
#define joyButton6 9
#define joyButton7 10
#define joyButton8 14
#define joyButton9 15
#define joyButton10 16
#define joyButton11 4
#define joyButton12 5
#define joyButton13 6
#define joyButton14 7

const bool intiAutoSendState = true ;

//set button default states
int lastButton1State = 0;
int lastButton2State = 0;
int lastButton3State = 0;
int lastButton4State = 0;
int lastButton5State = 0;
int lastButton6State = 0;
int lastButton7State = 0;
int lastButton8State = 0;
int lastButton9State = 0;
int lastButton10State = 0;
int lastButton11State = 0;
int lastButton12State = 0;
int lastButton13State = 0;
int lastButton14State = 0;





void setup() {
  // Initialize Button Pins
  pinMode(joyButton1, INPUT_PULLUP);
  pinMode(joyButton2, INPUT_PULLUP);
  pinMode(joyButton3, INPUT_PULLUP);
  pinMode(joyButton4, INPUT_PULLUP);
  pinMode(joyButton5, INPUT_PULLUP);
  pinMode(joyButton6, INPUT_PULLUP);
  pinMode(joyButton7, INPUT_PULLUP);
  pinMode(joyButton8, INPUT_PULLUP);
  pinMode(joyButton9, INPUT_PULLUP);
  pinMode(joyButton10, INPUT_PULLUP);
  pinMode(joyButton11, INPUT_PULLUP);
  pinMode(joyButton12, INPUT_PULLUP);
  pinMode(joyButton13, INPUT_PULLUP);
  pinMode(joyButton14, INPUT_PULLUP);

  // Initialize Joystick Library
  Joystick.begin();
}

// Constant that maps the phyical pin to the joystick button.
const int pinToButtonMap = 0;

// Last state of the button
int lastButtonState[14] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0};

void loop() {
  // Read pin values


int currentButton1State = !digitalRead(joyButton1);
  if (currentButton1State != lastButton1State){
  Joystick.setButton(0, currentButton1State);
  lastButton1State = currentButton1State;
}
int currentButton2State = !digitalRead(joyButton2);
  if (currentButton2State != lastButton2State){
  Joystick.setButton(1, currentButton2State);
  lastButton2State = currentButton2State;
}
int currentButton3State = !digitalRead(joyButton3);
  if (currentButton3State != lastButton3State){
  Joystick.setButton(2, currentButton3State);
  lastButton3State = currentButton3State;
}
int currentButton4State = !digitalRead(joyButton4);
  if (currentButton4State != lastButton4State){
  Joystick.setButton(3, currentButton4State);
  lastButton4State = currentButton4State;
}
int currentButton5State = !digitalRead(joyButton5);
  if (currentButton5State != lastButton5State){
  Joystick.setButton(4, currentButton5State);
  lastButton5State = currentButton5State;
}
int currentButton6State = !digitalRead(joyButton6);
  if (currentButton6State != lastButton6State){
  Joystick.setButton(5, currentButton6State);
  lastButton6State = currentButton6State;
}
int currentButton7State = !digitalRead(joyButton7);
  if (currentButton7State != lastButton7State){
  Joystick.setButton(6, currentButton7State);
  lastButton7State = currentButton7State;
}
int currentButton8State = !digitalRead(joyButton8);
  if (currentButton8State != lastButton8State){
  Joystick.setButton(7, currentButton8State);
  lastButton8State = currentButton8State;
}
int currentButton9State = !digitalRead(joyButton9);
  if (currentButton9State != lastButton9State){
  Joystick.setButton(8, currentButton9State);
  lastButton9State = currentButton9State;
}
int currentButton10State = !digitalRead(joyButton10);
  if (currentButton10State != lastButton10State){
  Joystick.setButton(9, currentButton10State);
  lastButton10State = currentButton10State;
}


//hat switch設定

  bool valueChanged = {false};

int hatSwitch = 0;
  
  // Read pin values
 
      int currentButton11State = !digitalRead(joyButton11);
      if (currentButton11State != lastButton11State)
      {
        valueChanged = true;
        lastButton11State = currentButton11State;
      }
        int currentButton12State = !digitalRead(joyButton12);
      if (currentButton12State != lastButton12State)
      {
        valueChanged = true;
        lastButton12State = currentButton12State;
      }
       int currentButton13State = !digitalRead(joyButton13);
      if (currentButton13State != lastButton13State)
      {
        valueChanged = true;
        lastButton13State = currentButton13State;
      }
       int currentButton14State = !digitalRead(joyButton14);
      if (currentButton14State != lastButton14State)
      {
        valueChanged = true;
        lastButton14State = currentButton14State;
      }
 

    if (valueChanged) {
      
      if ((lastButton11State == 0)
        && (lastButton12State == 0)
        && (lastButton13State == 0)
        && (lastButton14State == 0)) {
          Joystick.setHatSwitch(hatSwitch, -1);
      }
      if ((lastButton11State == 1) && (lastButton12State  == 0) && (lastButton14State == 0)){
        Joystick.setHatSwitch(hatSwitch, 0);
      }
      if ((lastButton11State == 1) 
      && (lastButton12State == 1)){
        Joystick.setHatSwitch(hatSwitch, 45);
      }
     if ((lastButton12State == 1) && (lastButton11State  == 0) && (lastButton13State == 0)){
        Joystick.setHatSwitch(hatSwitch, 90);
      }
      if ((lastButton12State == 1) 
      && (lastButton13State == 1)){
        Joystick.setHatSwitch(hatSwitch, 135);
      }
     if ((lastButton13State == 1) && (lastButton12State  == 0) && (lastButton14State == 0)){
        Joystick.setHatSwitch(hatSwitch, 180);
      }
      if ((lastButton13State == 1) 
      && (lastButton14State == 1)){
        Joystick.setHatSwitch(hatSwitch, 225);
      }
     if ((lastButton14State == 1) && (lastButton13State  == 0) && (lastButton11State == 0)){
        Joystick.setHatSwitch(hatSwitch, 270);
      }
      if ((lastButton14State == 1) 
      && (lastButton11State == 1)){
        Joystick.setHatSwitch(hatSwitch, 315);
      }
      
    } // if the value changed


  delay(50);
}
